        page    66,80
        TITLE   SPAWN.COM 1.3 Spawning teaching example
;       by Roedy Green
;       works with MASM 5.0 and Optasm

COMMENT 

        This program is copyrighted but may be used freely
        for any purpose except military.

 SPAWN  ۲


Used to SPAWN (shell out to, exec a) CHILD program.  This
program has no practical use, as is. It is just a teaching
example.  It also acts as a skeleton you can cannibalize from to
create your own real-life programs.  (What a mangled metaphor!)
I have left out the analysis of child failure.

This program is copyrighted but may be used freely for any
purpose except military.  Love Roedy

Note the program spawned must have *.COM or *.EXE extension.  It
must be explicitly stated.  Spawn CANNOT handle *.BAT files.
The program spawned must be fully qualified or in the current
directory.  Spawn (or rather DOS spawn) does NOT search the
path.  You could of course spawn COMMAND.COM and thereby
indirectly spawn a BAT FILE.  Normally you would look at COMSPEC
in the environment in case COMMAND.COM were in an unusual place
or 4DOS were the command processor.

There is a more elaborate version of SPAWN called SHELL that
shrinks itself down before spawning the child.

Please report bugs and problems to:

Roedy Green
Canadian Mind Products
#208 - 525 Ninth Street
New Westminster BC Canada
V5H 2N6
tel:(604) 777-1804
mailto:roedy@mindprod.com
http://mindprod.com


Version 1.3 1998 November 8
- embed Barker address

Version 1.2 1996 October 25
- embed POB 707 Quathiaski Cove address

; 


SAY     MACRO   Msg             ; display message on screen
        LEA     DX,&Msg         ; use LEA rather than
                                ; MOV Offset for more generality
        MOV     AH,09h
        INT     21h
        ENDM

;==============================================================

stack   segment stack           ; keep MS link happy by providing null stack
stack   ends

;==============================================================

CODE    SEGMENT PARA            ; start off in code.

;==============================================================

data    segment byte            ; provide a separate DATA segment
                                ; actually all come after the code

FirstData       Label   Word

;==============================================================
;  V A R I A B L E S

DummyFCB        db      0, 11 dup(" ")

ChildTail               db      0,256 dup (" "),0dh
                                ; e.g. 2,"/X",0dh
                                ; build command tail here, with length
                                ; byte and trailing Cr, not included in
                                ; length


ParmBlock       label   Word    ; communication region with child
EnvSeg          DW      0       ; address of child's environment region
                                ; leave zero so child sees our ENV.
                                ; Note 0 offset presumed.
TailOff         DW      0       ; Address of child's command line
Tailseg         DW      0
FCB1Off         DW      0       ; address of child's first FCB
FCB1Seg         DW      0
FCB2Off         DW      0       ; address of child's second FCB
FCB2Seg         DW      0


CHILDName       DB      64 dup (0)      ; e.g. "C:\MySub\Myprog.Exe",0
                                ; must be fully qualified or in the current dir.
                                ; Spawn will not search the path.
                                ; must have explicit .COM or .EXE,
                                ; no .BAT, no leaving extension off.

CHILDParm       DB      64 dup (0)      ; e.g. "/X",0
                                ; command line for child.
                                ; Here, comes from parent's command line
;==============================================================
;  C O N S T A N T S

;               AsciiZ constants

SPACES          DB      "  ",0
CrLf            DB      13,10,0


;==============================================================
; M E S S A G E S

BannerMsg       label   byte
        DB      13,10
        DB      ' SPAWN 1.3  ۲',13d,10d
        DB      13d,10d
        DB      'Sample program to demonstrate spawning.',13,10
        DB      13,10
        DB      'Copyright (c) 1991,1998 Roedy Green Canadian Mind Products.',13,10
        DB      '#208 - 525 Ninth Street, New Westminster, BC Canada V3M 5T9',13,10
        DB      'tel:(604) 777-1804   mailto:roedy@mindprod.com   http://mindprod.com',13,10
        DB      'May be freely distributed and used for any purpose except military.',13,10,13,10
        db      '$'

UsageMsg        db 13,10
                db 'Try:',13,10
                db 'SPAWN  C:\MYCHILD.EXE  /XXXX',13,10
                db 'when /XXX represents an arbitrary parameter for the child',13,10
                db 'Child must have explicit .COM or .EXE extension.',13,10
                db '$'

StartMsg        db 13,10
                db ' SPAWN 1.3 ۲ Starting child program . . .',13,10
                db '$'

DoneMsg         db 13,10
                db ' SPAWN 1.3 ۲ Complete',13,10
                db '$'

SyntaxErrMsg    db 13,10
                db 'Syntax error in command line',13,10
                db '$'

NoRamMsg        db 13,10
                db 'Not enough RAM to SPAWN.  Try removing TSRs or rebooting.',13,10
                db '$'

ChildFailMsg    db 13,10
                db 'Child failed. Why?',13,10
                db 'Insufficient RAM, missing program, missing/wrong extension, non-zero ret code.',13,10
                db '$'

LastData        Label   Word
data            ends

;==============================================================

com     group   code,data       ; force data segment to go at the end!

        ASSUME  CS:com,DS:com,ES:com,SS:com
                                ; seg regs cover everything
        ORG     100H            ; in Code segment

;==============================================================

Start   proc    far
;       Mainline procedure

;=============================
FirstCode       Label   Word

; P R E P A R A T I O N
Restart:                        ; jump back to beginning to try again
        Say     BannerMsg       ; display the copyright banner
        Call    Init            ; initialize command blocks
        Call    Parse           ; parse command line

RamNeeded = 100h+1024+(LastCode-FirstCode)+(LastData-FirstData)
ParasNeeded = (RamNeeded+15)/16 ; calculation done at assembly time
                                ; allow 100h PSP, and 1024 byte stack
                                ; rounded up to paragraphs
        mov     BX,ParasNeeded
        Call    ResizeRam       ; free up ram for use by Child

; S P A W N   T H E  C H I L D
        Say     StartMsg
        CALL    ClearTail       ; generate child's command line
        lea     si,CHILDParm
        call    AppendToTail
                                ; could add extra stuff to child's
                                ; command tail here.
        LEA     DX,ChildName    ; executable
        LEA     BX,ParmBlock    ; pointers to FCBS and ENV
        MOV     AX,4B00h        ; load and execute child process
        INT     21h
        JC      ChildFail       ; probably no such program on path
                                ; or not enough ram.
        Call    CheckRetCode    ; check return code
        jnz     ChildFail

        Say     DoneMsg
        MOV     AX,4C00H        ; EXIT with return code 0
        INT     21H

;=============================

; E R R O R S

SyntaxErr:
        Say     SyntaxErrMsg            ; syntax error
        Say     UsageMsg
        jmp     Abort

NoRam:
        Say     NoRamMsg                ; not enough RAM for us.
        jmp     Abort

ChildFail:
        Say     ChildFailMsg
        jmp     Abort

Abort:
        MOV     AX,4C04H        ; ABORT
        INT     21H
;=============================

Init    Proc    Near
;       Init command blocks.  Cannot do this at assembly time as seg unknown.
        LEA     SI,ChildTail
        MOV     TailSeg,DS
        MOV     TailOff,SI

        LEA     SI,DummyFCB
        MOV     FCB1Seg,DS
        MOV     FCB1Off,SI
        MOV     FCB2Seg,DS
        MOV     FCB2Off,SI
        RET
Init    EndP

;=============================


Parse   Proc    Near
;                               ; GET CHILDNAME
        Call    CommandLine
        mov     bx,1
        Call    NthParm
                                ; si points to string, cx is len
        lea     di,CHILDName
        cmp     cx,1
        jl      SyntaxErr
        cmp     cx,63
        jg      SyntaxErr
        rep movsb               ; save parm in CHILDName ASCIIZ variable

;                               ; GET CHILDPARM
        Call    CommandLine
        mov     bx,2
        Call    NthParm
                                ; si points to string, cx is len
        lea     di,CHILDParm    ; save, will have 0 bit initialization
        and     cx,63
        rep movsb               ; save parm in CHILDParm ASCIIZ variable
        RET
Parse   EndP

;=============================

ResizeRam       Proc    Near
;       Spawning must be done into free RAM.  We must give back RAM
;       to the pool.  We presume we are always shrinking.
;       Move stack to new lower place first
;       On entry BX has size of entire region in paragraphs
        MOV     AX,BX
        SHL     AX,1
        SHL     AX,1
        SHL     AX,1
        SHL     AX,1            ; AX=desired size of region in bytes
        SUB     AX,16           ; point SP with 16 byte safety margin just
                                ; under the end of the new region size
        POP     CX              ; preserve our return address, 1 level only
        MOV     SP,AX
        PUSH    CX              ; restore our return address
        MOV     AH,4Ah
        INT     21H
        JC      NoRam           ; some trouble with resize
        RET
ResizeRam       EndP

;=============================

CheckRetCode    Proc    Near
; check return code from last spawn
        mov     ah,4Dh
        int     21h
;                               ; ax is the return code
        or      ax,ax
        ret
CheckRetCode    EndP

;=============================

ClearTail       Proc    Near
;       Clear command line we will give to the child
        MOV     ChildTail,0
        MOV     ChildTail+1,0dh
        RET
ClearTail       EndP

;=============================

AppendToTail    Proc    Near
;       tack string pointed to by si onto end of current ChildTail
;       ChildTail starts with count, terminated by Cr.
;       String to tack on is ASCIIZ.
        mov     bx,si           ; save addr of appending string
        lea     si,ChildTail
        xor     ax,ax
        lodsb                   ; get length byte
        add     si,ax           ; location to append at
        mov     di,si
        mov     si,bx
AppendLoop:                     ; si = append  di=end of tail
        lodsb                   ; pick up one char from string
        cmp     al,0            ; look for nul terminator
        je      AppendDone
        stosb                   ; tack onto end of tail
        inc     ChildTail       ; fix count (inefficiency is not important here)
        jmp     AppendLoop
AppendDone:
        mov     al,0dh          ; plop in terminating Cr
        stosb
        ret
AppendToTail    EndP

;=============================

SayASCIIZ       proc
;       on entry DS:DX points to an ASCIIZ string to display
;       Scan for 0 at end of string counting bytes, then display it.
        mov     si,dx
        mov     cx,-1
ScanASCIIZ:
        inc     cx
        lodsb
        cmp     al,0
        Jne     ScanAsciiz

;       display string at ds:dx cx bytes long
;                               ; dx still points to start of string
        mov     bx,1            ; handle 1 - stdout will be redirected
        mov     ax,4000h        ; AH=40 signifies write by handle
        int     21h             ; DOS WRITE STRING
        ret
SayASCIIZ       endp

;=============================

NthParm Proc    Near
;       Parses string for Nth Parameter delimited by blanks
;       e.g.  "  bright blue" with BX=1 would give string "bright"
;       ES:DI - string to be parsed for parameters
;       CX - length of string
;       BX - which parm wanted 1=parm1 2=parm2 etc.
;       NthParm only finds one parm per call.
;       On exit ES:SI points to string and CX is its length.
;       If there is no parm, the length will be 0.
;       It also handles multiple leading/trailing blanks on parms.
;       Usually the string is the command line
        MOV     AL,20h          ; AL = blank  -- the search char
ParmLoop:
;       Remove leading blanks on parm
        JCXZ    NullParm        ; jump if null string
        REPE    SCASB           ; scan ES:DI forwards till hit non blank
                                ; DI points just after it
                                ; CX is one too small, or 0 if none found
        JE      NullParm        ; jump if entire string was blank
        INC     CX              ; CX is length of remainder of string
        DEC     DI              ; DI points to non-blank
        MOV     SI,DI           ; remember start of string
;       Search for terminating blank on parm
        JCXZ    NullParm        ; jump if null string
        REPNE   SCASB           ; scan ES:DI forwards till hit blank
                                ; DI points just after it
                                ; CX is one too small, or 0 if none found
        JNE     NoBlank         ; jump if entire string was non blank
        INC     CX              ; CX is length of remainder of string
        DEC     DI              ; backup DI to point to blank at string end
NoBlank:
                                ; DI=addr tail end of command string,
                                ; CX=len tail end of command string
                                ; SI=addr parm just parsed
;       Major loop for each parm
        DEC     BX
        JNZ     ParmLoop        ; loop once for each parm

        MOV     CX,DI
        SUB     CX,SI           ; CX is length of parameter.
        RET
NullParm:                       ; was no nth parameter
        MOV     CX,0
        RET
NthParm EndP

;=============================

CommandLine Proc        Near
;       Gets command line string into ES:DI
;       Command line does not include the program name.
;       ES already set since we are a COM file
                                ; counted string at HEX 80
                                ; contains command line.
                                ; It has no trailing null.
        MOV     DI,81h
        XOR     CH,CH
        MOV     CL,DS:80h       ; CX contains length of command
        RET
CommandLine EndP

;=============================
LastCode Label  word    ; last byte of RAM
;=============================

Start   endp

;==========================
CODE    ends                    ; end of code segment
        end     Start
